/* game.c generated by valac 0.44.0, the Vala compiler
 * generated from game.vala, do not modify */

/*
 * Copyright (C) 2010-2013 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib-object.h>
#include <glib.h>
#include <math.h>

#define TYPE_TILE (tile_get_type ())
#define TILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TILE, Tile))
#define TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TILE, TileClass))
#define IS_TILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TILE))
#define IS_TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TILE))
#define TILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TILE, TileClass))

typedef struct _Tile Tile;
typedef struct _TileClass TileClass;
typedef struct _TilePrivate TilePrivate;
enum  {
	TILE_0_PROPERTY,
	TILE_CLOSED_PROPERTY,
	TILE_NUM_PROPERTIES
};
static GParamSpec* tile_properties[TILE_NUM_PROPERTIES];
enum  {
	TILE_MOVE_SIGNAL,
	TILE_CLOSE_SIGNAL,
	TILE_NUM_SIGNALS
};
static guint tile_signals[TILE_NUM_SIGNALS] = {0};

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
typedef struct _GamePrivate GamePrivate;
enum  {
	GAME_0_PROPERTY,
	GAME_SCORE_PROPERTY,
	GAME_COLOR_NUM_PROPERTY,
	GAME_ROWS_PROPERTY,
	GAME_COLUMNS_PROPERTY,
	GAME_NUM_PROPERTIES
};
static GParamSpec* game_properties[GAME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	GAME_UPDATE_SCORE_SIGNAL,
	GAME_COMPLETE_SIGNAL,
	GAME_STARTED_SIGNAL,
	GAME_NUM_SIGNALS
};
static guint game_signals[GAME_NUM_SIGNALS] = {0};

struct _Tile {
	GObject parent_instance;
	TilePrivate * priv;
	gint grid_x;
	gint grid_y;
	gint color;
	gboolean visited;
};

struct _TileClass {
	GObjectClass parent_class;
};

struct _TilePrivate {
	gboolean _closed;
};

struct _Game {
	GObject parent_instance;
	GamePrivate * priv;
};

struct _GameClass {
	GObjectClass parent_class;
};

struct _GamePrivate {
	Tile** tiles;
	gint tiles_length1;
	gint tiles_length2;
	gboolean is_started;
	gint _score;
	gint _color_num;
	gint _rows;
	gint _columns;
};

static gint Tile_private_offset;
static gpointer tile_parent_class = NULL;
static gint Game_private_offset;
static gpointer game_parent_class = NULL;

GType tile_get_type (void) G_GNUC_CONST;
Tile* tile_new (gint x,
                gint y,
                gint c);
Tile* tile_construct (GType object_type,
                      gint x,
                      gint y,
                      gint c);
void tile_update_position (Tile* self,
                           gint new_x,
                           gint new_y);
gboolean tile_get_closed (Tile* self);
void tile_set_closed (Tile* self,
                      gboolean value);
static void g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data);
static void tile_finalize (GObject * obj);
static void _vala_tile_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_tile_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);
GType game_get_type (void) G_GNUC_CONST;
Game* game_new (gint rows,
                gint columns,
                gint color_num);
Game* game_construct (GType object_type,
                      gint rows,
                      gint columns,
                      gint color_num);
static GList* _game_connected_tiles (Game* self,
                              Tile* li);
gint game_get_rows (Game* self);
gint game_get_columns (Game* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
GList* game_connected_tiles (Game* self,
                             Tile* li);
Tile* game_get_tile (Game* self,
                     gint x,
                     gint y);
gboolean game_remove_connected_tiles (Game* self,
                                      Tile* tile);
void game_increment_score_from_tiles (Game* self,
                                      gint n_tiles);
gboolean game_has_completed (Game* self);
gboolean game_has_won (Game* self);
void game_increment_score (Game* self,
                           gint increment);
void game_reset_visit (Game* self);
gint game_get_score (Game* self);
void game_set_score (Game* self,
                     gint value);
gint game_get_color_num (Game* self);
void game_set_color_num (Game* self,
                         gint value);
void game_set_rows (Game* self,
                    gint value);
void game_set_columns (Game* self,
                       gint value);
static void game_finalize (GObject * obj);
static void _vala_game_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_game_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
tile_get_instance_private (Tile* self)
{
	return G_STRUCT_MEMBER_P (self, Tile_private_offset);
}

Tile*
tile_construct (GType object_type,
                gint x,
                gint y,
                gint c)
{
	Tile * self = NULL;
#line 40 "../src/game.vala"
	self = (Tile*) g_object_new (object_type, NULL);
#line 42 "../src/game.vala"
	self->grid_x = x;
#line 43 "../src/game.vala"
	self->grid_y = y;
#line 44 "../src/game.vala"
	self->color = c;
#line 40 "../src/game.vala"
	return self;
#line 224 "game.c"
}

Tile*
tile_new (gint x,
          gint y,
          gint c)
{
#line 40 "../src/game.vala"
	return tile_construct (TYPE_TILE, x, y, c);
#line 234 "game.c"
}

void
tile_update_position (Tile* self,
                      gint new_x,
                      gint new_y)
{
	gint old_x = 0;
	gint old_y = 0;
	gboolean _tmp0_ = FALSE;
#line 48 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/game.vala"
	old_x = self->grid_x;
#line 51 "../src/game.vala"
	old_y = self->grid_y;
#line 53 "../src/game.vala"
	if (new_x != old_x) {
#line 53 "../src/game.vala"
		_tmp0_ = TRUE;
#line 255 "game.c"
	} else {
#line 53 "../src/game.vala"
		_tmp0_ = new_y != old_y;
#line 259 "game.c"
	}
#line 53 "../src/game.vala"
	if (_tmp0_) {
#line 263 "game.c"
		gboolean _tmp1_;
		gboolean _tmp2_;
#line 55 "../src/game.vala"
		self->grid_x = new_x;
#line 56 "../src/game.vala"
		self->grid_y = new_y;
#line 59 "../src/game.vala"
		_tmp1_ = tile_get_closed (self);
#line 59 "../src/game.vala"
		_tmp2_ = _tmp1_;
#line 59 "../src/game.vala"
		if (!_tmp2_) {
#line 60 "../src/game.vala"
			g_signal_emit (self, tile_signals[TILE_MOVE_SIGNAL], 0, old_x, old_y, new_x, new_y);
#line 278 "game.c"
		}
	}
}

gboolean
tile_get_closed (Tile* self)
{
	gboolean result;
#line 20 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 20 "../src/game.vala"
	result = self->priv->_closed;
#line 20 "../src/game.vala"
	return result;
#line 293 "game.c"
}

void
tile_set_closed (Tile* self,
                 gboolean value)
{
#line 21 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/game.vala"
	self->priv->_closed = value;
#line 25 "../src/game.vala"
	if (self->priv->_closed) {
#line 26 "../src/game.vala"
		g_signal_emit (self, tile_signals[TILE_CLOSE_SIGNAL], 0, self->grid_x, self->grid_y);
#line 308 "game.c"
	}
#line 21 "../src/game.vala"
	g_object_notify_by_pspec ((GObject *) self, tile_properties[TILE_CLOSED_PROPERTY]);
#line 312 "game.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_INT_INT) (gpointer data1, gint arg_1, gint arg_2, gint arg_3, gint arg_4, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 14 "../src/game.vala"
	g_return_if_fail (n_param_values == 5);
#line 14 "../src/game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 14 "../src/game.vala"
		data1 = closure->data;
#line 14 "../src/game.vala"
		data2 = param_values->data[0].v_pointer;
#line 337 "game.c"
	} else {
#line 14 "../src/game.vala"
		data1 = param_values->data[0].v_pointer;
#line 14 "../src/game.vala"
		data2 = closure->data;
#line 343 "game.c"
	}
#line 14 "../src/game.vala"
	callback = (GMarshalFunc_VOID__INT_INT_INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 14 "../src/game.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), g_value_get_int (param_values + 4), data2);
#line 349 "game.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                       GValue * return_value,
                                       guint n_param_values,
                                       const GValue * param_values,
                                       gpointer invocation_hint,
                                       gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 14 "../src/game.vala"
	g_return_if_fail (n_param_values == 3);
#line 14 "../src/game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 14 "../src/game.vala"
		data1 = closure->data;
#line 14 "../src/game.vala"
		data2 = param_values->data[0].v_pointer;
#line 374 "game.c"
	} else {
#line 14 "../src/game.vala"
		data1 = param_values->data[0].v_pointer;
#line 14 "../src/game.vala"
		data2 = closure->data;
#line 380 "game.c"
	}
#line 14 "../src/game.vala"
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 14 "../src/game.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 386 "game.c"
}

static void
tile_class_init (TileClass * klass,
                 gpointer klass_data)
{
#line 14 "../src/game.vala"
	tile_parent_class = g_type_class_peek_parent (klass);
#line 14 "../src/game.vala"
	g_type_class_adjust_private_offset (klass, &Tile_private_offset);
#line 14 "../src/game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tile_get_property;
#line 14 "../src/game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tile_set_property;
#line 14 "../src/game.vala"
	G_OBJECT_CLASS (klass)->finalize = tile_finalize;
#line 14 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TILE_CLOSED_PROPERTY, tile_properties[TILE_CLOSED_PROPERTY] = g_param_spec_boolean ("closed", "closed", "closed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 14 "../src/game.vala"
	tile_signals[TILE_MOVE_SIGNAL] = g_signal_new ("move", TYPE_TILE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_INT_INT, G_TYPE_NONE, 4, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT);
#line 14 "../src/game.vala"
	tile_signals[TILE_CLOSE_SIGNAL] = g_signal_new ("close", TYPE_TILE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
#line 409 "game.c"
}

static void
tile_instance_init (Tile * self,
                    gpointer klass)
{
#line 14 "../src/game.vala"
	self->priv = tile_get_instance_private (self);
#line 17 "../src/game.vala"
	self->priv->_closed = FALSE;
#line 33 "../src/game.vala"
	self->visited = FALSE;
#line 422 "game.c"
}

static void
tile_finalize (GObject * obj)
{
	Tile * self;
#line 14 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TILE, Tile);
#line 14 "../src/game.vala"
	G_OBJECT_CLASS (tile_parent_class)->finalize (obj);
#line 433 "game.c"
}

/**
 *  This is the model layer of a tile.
 */
GType
tile_get_type (void)
{
	static volatile gsize tile_type_id__volatile = 0;
	if (g_once_init_enter (&tile_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tile_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Tile), 0, (GInstanceInitFunc) tile_instance_init, NULL };
		GType tile_type_id;
		tile_type_id = g_type_register_static (G_TYPE_OBJECT, "Tile", &g_define_type_info, 0);
		Tile_private_offset = g_type_add_instance_private (tile_type_id, sizeof (TilePrivate));
		g_once_init_leave (&tile_type_id__volatile, tile_type_id);
	}
	return tile_type_id__volatile;
}

static void
_vala_tile_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Tile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TILE, Tile);
#line 14 "../src/game.vala"
	switch (property_id) {
#line 14 "../src/game.vala"
		case TILE_CLOSED_PROPERTY:
#line 14 "../src/game.vala"
		g_value_set_boolean (value, tile_get_closed (self));
#line 14 "../src/game.vala"
		break;
#line 469 "game.c"
		default:
#line 14 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/game.vala"
		break;
#line 475 "game.c"
	}
}

static void
_vala_tile_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Tile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TILE, Tile);
#line 14 "../src/game.vala"
	switch (property_id) {
#line 14 "../src/game.vala"
		case TILE_CLOSED_PROPERTY:
#line 14 "../src/game.vala"
		tile_set_closed (self, g_value_get_boolean (value));
#line 14 "../src/game.vala"
		break;
#line 495 "game.c"
		default:
#line 14 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 14 "../src/game.vala"
		break;
#line 501 "game.c"
	}
}

static inline gpointer
game_get_instance_private (Game* self)
{
	return G_STRUCT_MEMBER_P (self, Game_private_offset);
}

Game*
game_construct (GType object_type,
                gint rows,
                gint columns,
                gint color_num)
{
	Game * self = NULL;
	Tile** _tmp0_;
#line 99 "../src/game.vala"
	self = (Game*) g_object_new (object_type, NULL);
#line 101 "../src/game.vala"
	self->priv->_rows = rows;
#line 102 "../src/game.vala"
	self->priv->_columns = columns;
#line 103 "../src/game.vala"
	self->priv->_color_num = color_num;
#line 106 "../src/game.vala"
	_tmp0_ = g_new0 (Tile*, (rows * columns) + 1);
#line 106 "../src/game.vala"
	self->priv->tiles = (_vala_array_free (self->priv->tiles, self->priv->tiles_length1 * self->priv->tiles_length2, (GDestroyNotify) g_object_unref), NULL);
#line 106 "../src/game.vala"
	self->priv->tiles = _tmp0_;
#line 106 "../src/game.vala"
	self->priv->tiles_length1 = rows;
#line 106 "../src/game.vala"
	self->priv->tiles_length2 = columns;
#line 537 "game.c"
	{
		gint x = 0;
#line 108 "../src/game.vala"
		x = 0;
#line 542 "game.c"
		{
			gboolean _tmp1_ = FALSE;
#line 108 "../src/game.vala"
			_tmp1_ = TRUE;
#line 108 "../src/game.vala"
			while (TRUE) {
#line 108 "../src/game.vala"
				if (!_tmp1_) {
#line 551 "game.c"
					gint _tmp2_;
#line 108 "../src/game.vala"
					_tmp2_ = x;
#line 108 "../src/game.vala"
					x = _tmp2_ + 1;
#line 557 "game.c"
				}
#line 108 "../src/game.vala"
				_tmp1_ = FALSE;
#line 108 "../src/game.vala"
				if (!(x < columns)) {
#line 108 "../src/game.vala"
					break;
#line 565 "game.c"
				}
				{
					gint y = 0;
#line 110 "../src/game.vala"
					y = 0;
#line 571 "game.c"
					{
						gboolean _tmp3_ = FALSE;
#line 110 "../src/game.vala"
						_tmp3_ = TRUE;
#line 110 "../src/game.vala"
						while (TRUE) {
#line 578 "game.c"
							gint c = 0;
							Tile** _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
							Tile* _tmp6_;
#line 110 "../src/game.vala"
							if (!_tmp3_) {
#line 586 "game.c"
								gint _tmp4_;
#line 110 "../src/game.vala"
								_tmp4_ = y;
#line 110 "../src/game.vala"
								y = _tmp4_ + 1;
#line 592 "game.c"
							}
#line 110 "../src/game.vala"
							_tmp3_ = FALSE;
#line 110 "../src/game.vala"
							if (!(y < rows)) {
#line 110 "../src/game.vala"
								break;
#line 600 "game.c"
							}
#line 112 "../src/game.vala"
							c = (gint) floor (g_random_double () * color_num);
#line 113 "../src/game.vala"
							_tmp5_ = self->priv->tiles;
#line 113 "../src/game.vala"
							_tmp5__length1 = self->priv->tiles_length1;
#line 113 "../src/game.vala"
							_tmp5__length2 = self->priv->tiles_length2;
#line 113 "../src/game.vala"
							_tmp6_ = tile_new (x, y, c);
#line 113 "../src/game.vala"
							_g_object_unref0 (_tmp5_[(y * _tmp5__length2) + x]);
#line 113 "../src/game.vala"
							_tmp5_[(y * _tmp5__length2) + x] = _tmp6_;
#line 616 "game.c"
						}
					}
				}
			}
		}
	}
#line 117 "../src/game.vala"
	self->priv->is_started = FALSE;
#line 99 "../src/game.vala"
	return self;
#line 627 "game.c"
}

Game*
game_new (gint rows,
          gint columns,
          gint color_num)
{
#line 99 "../src/game.vala"
	return game_construct (TYPE_GAME, rows, columns, color_num);
#line 637 "game.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 133 "../src/game.vala"
	return self ? g_object_ref (self) : NULL;
#line 645 "game.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 121 "../src/game.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 653 "game.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 121 "../src/game.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 661 "game.c"
}

static GList*
_game_connected_tiles (Game* self,
                       Tile* li)
{
	GList* result = NULL;
	GList* cl = NULL;
	gboolean _tmp0_ = FALSE;
	gint x = 0;
	gint y = 0;
	Tile* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gint _tmp6_;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp24_ = FALSE;
	gint _tmp25_;
	gboolean _tmp33_ = FALSE;
	gboolean _tmp34_ = FALSE;
#line 121 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 123 "../src/game.vala"
	cl = NULL;
#line 125 "../src/game.vala"
	if (li->visited) {
#line 125 "../src/game.vala"
		_tmp0_ = TRUE;
#line 692 "game.c"
	} else {
		gboolean _tmp1_;
		gboolean _tmp2_;
#line 125 "../src/game.vala"
		_tmp1_ = tile_get_closed (li);
#line 125 "../src/game.vala"
		_tmp2_ = _tmp1_;
#line 125 "../src/game.vala"
		_tmp0_ = _tmp2_;
#line 702 "game.c"
	}
#line 125 "../src/game.vala"
	if (_tmp0_) {
#line 126 "../src/game.vala"
		result = cl;
#line 126 "../src/game.vala"
		return result;
#line 710 "game.c"
	}
#line 128 "../src/game.vala"
	x = li->grid_x;
#line 129 "../src/game.vala"
	y = li->grid_y;
#line 131 "../src/game.vala"
	li->visited = TRUE;
#line 133 "../src/game.vala"
	_tmp3_ = _g_object_ref0 (li);
#line 133 "../src/game.vala"
	cl = g_list_append (cl, _tmp3_);
#line 135 "../src/game.vala"
	_tmp6_ = self->priv->_rows;
#line 135 "../src/game.vala"
	if ((y + 1) < _tmp6_) {
#line 726 "game.c"
		Tile** _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		Tile* _tmp8_;
#line 135 "../src/game.vala"
		_tmp7_ = self->priv->tiles;
#line 135 "../src/game.vala"
		_tmp7__length1 = self->priv->tiles_length1;
#line 135 "../src/game.vala"
		_tmp7__length2 = self->priv->tiles_length2;
#line 135 "../src/game.vala"
		_tmp8_ = _tmp7_[((y + 1) * _tmp7__length2) + x];
#line 135 "../src/game.vala"
		_tmp5_ = _tmp8_ != NULL;
#line 741 "game.c"
	} else {
#line 135 "../src/game.vala"
		_tmp5_ = FALSE;
#line 745 "game.c"
	}
#line 135 "../src/game.vala"
	if (_tmp5_) {
#line 749 "game.c"
		Tile** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		Tile* _tmp10_;
#line 135 "../src/game.vala"
		_tmp9_ = self->priv->tiles;
#line 135 "../src/game.vala"
		_tmp9__length1 = self->priv->tiles_length1;
#line 135 "../src/game.vala"
		_tmp9__length2 = self->priv->tiles_length2;
#line 135 "../src/game.vala"
		_tmp10_ = _tmp9_[((y + 1) * _tmp9__length2) + x];
#line 135 "../src/game.vala"
		_tmp4_ = li->color == _tmp10_->color;
#line 764 "game.c"
	} else {
#line 135 "../src/game.vala"
		_tmp4_ = FALSE;
#line 768 "game.c"
	}
#line 135 "../src/game.vala"
	if (_tmp4_) {
#line 772 "game.c"
		Tile** _tmp11_;
		gint _tmp11__length1;
		gint _tmp11__length2;
		Tile* _tmp12_;
		GList* _tmp13_;
#line 136 "../src/game.vala"
		_tmp11_ = self->priv->tiles;
#line 136 "../src/game.vala"
		_tmp11__length1 = self->priv->tiles_length1;
#line 136 "../src/game.vala"
		_tmp11__length2 = self->priv->tiles_length2;
#line 136 "../src/game.vala"
		_tmp12_ = _tmp11_[((y + 1) * _tmp11__length2) + x];
#line 136 "../src/game.vala"
		_tmp13_ = _game_connected_tiles (self, _tmp12_);
#line 136 "../src/game.vala"
		cl = g_list_concat (cl, _tmp13_);
#line 790 "game.c"
	}
#line 138 "../src/game.vala"
	if ((y - 1) >= 0) {
#line 794 "game.c"
		Tile** _tmp16_;
		gint _tmp16__length1;
		gint _tmp16__length2;
		Tile* _tmp17_;
#line 138 "../src/game.vala"
		_tmp16_ = self->priv->tiles;
#line 138 "../src/game.vala"
		_tmp16__length1 = self->priv->tiles_length1;
#line 138 "../src/game.vala"
		_tmp16__length2 = self->priv->tiles_length2;
#line 138 "../src/game.vala"
		_tmp17_ = _tmp16_[((y - 1) * _tmp16__length2) + x];
#line 138 "../src/game.vala"
		_tmp15_ = _tmp17_ != NULL;
#line 809 "game.c"
	} else {
#line 138 "../src/game.vala"
		_tmp15_ = FALSE;
#line 813 "game.c"
	}
#line 138 "../src/game.vala"
	if (_tmp15_) {
#line 817 "game.c"
		Tile** _tmp18_;
		gint _tmp18__length1;
		gint _tmp18__length2;
		Tile* _tmp19_;
#line 138 "../src/game.vala"
		_tmp18_ = self->priv->tiles;
#line 138 "../src/game.vala"
		_tmp18__length1 = self->priv->tiles_length1;
#line 138 "../src/game.vala"
		_tmp18__length2 = self->priv->tiles_length2;
#line 138 "../src/game.vala"
		_tmp19_ = _tmp18_[((y - 1) * _tmp18__length2) + x];
#line 138 "../src/game.vala"
		_tmp14_ = li->color == _tmp19_->color;
#line 832 "game.c"
	} else {
#line 138 "../src/game.vala"
		_tmp14_ = FALSE;
#line 836 "game.c"
	}
#line 138 "../src/game.vala"
	if (_tmp14_) {
#line 840 "game.c"
		Tile** _tmp20_;
		gint _tmp20__length1;
		gint _tmp20__length2;
		Tile* _tmp21_;
		GList* _tmp22_;
#line 139 "../src/game.vala"
		_tmp20_ = self->priv->tiles;
#line 139 "../src/game.vala"
		_tmp20__length1 = self->priv->tiles_length1;
#line 139 "../src/game.vala"
		_tmp20__length2 = self->priv->tiles_length2;
#line 139 "../src/game.vala"
		_tmp21_ = _tmp20_[((y - 1) * _tmp20__length2) + x];
#line 139 "../src/game.vala"
		_tmp22_ = _game_connected_tiles (self, _tmp21_);
#line 139 "../src/game.vala"
		cl = g_list_concat (cl, _tmp22_);
#line 858 "game.c"
	}
#line 141 "../src/game.vala"
	_tmp25_ = self->priv->_columns;
#line 141 "../src/game.vala"
	if ((x + 1) < _tmp25_) {
#line 864 "game.c"
		Tile** _tmp26_;
		gint _tmp26__length1;
		gint _tmp26__length2;
		Tile* _tmp27_;
#line 141 "../src/game.vala"
		_tmp26_ = self->priv->tiles;
#line 141 "../src/game.vala"
		_tmp26__length1 = self->priv->tiles_length1;
#line 141 "../src/game.vala"
		_tmp26__length2 = self->priv->tiles_length2;
#line 141 "../src/game.vala"
		_tmp27_ = _tmp26_[(y * _tmp26__length2) + (x + 1)];
#line 141 "../src/game.vala"
		_tmp24_ = _tmp27_ != NULL;
#line 879 "game.c"
	} else {
#line 141 "../src/game.vala"
		_tmp24_ = FALSE;
#line 883 "game.c"
	}
#line 141 "../src/game.vala"
	if (_tmp24_) {
#line 887 "game.c"
		Tile** _tmp28_;
		gint _tmp28__length1;
		gint _tmp28__length2;
		Tile* _tmp29_;
#line 141 "../src/game.vala"
		_tmp28_ = self->priv->tiles;
#line 141 "../src/game.vala"
		_tmp28__length1 = self->priv->tiles_length1;
#line 141 "../src/game.vala"
		_tmp28__length2 = self->priv->tiles_length2;
#line 141 "../src/game.vala"
		_tmp29_ = _tmp28_[(y * _tmp28__length2) + (x + 1)];
#line 141 "../src/game.vala"
		_tmp23_ = li->color == _tmp29_->color;
#line 902 "game.c"
	} else {
#line 141 "../src/game.vala"
		_tmp23_ = FALSE;
#line 906 "game.c"
	}
#line 141 "../src/game.vala"
	if (_tmp23_) {
#line 910 "game.c"
		Tile** _tmp30_;
		gint _tmp30__length1;
		gint _tmp30__length2;
		Tile* _tmp31_;
		GList* _tmp32_;
#line 142 "../src/game.vala"
		_tmp30_ = self->priv->tiles;
#line 142 "../src/game.vala"
		_tmp30__length1 = self->priv->tiles_length1;
#line 142 "../src/game.vala"
		_tmp30__length2 = self->priv->tiles_length2;
#line 142 "../src/game.vala"
		_tmp31_ = _tmp30_[(y * _tmp30__length2) + (x + 1)];
#line 142 "../src/game.vala"
		_tmp32_ = _game_connected_tiles (self, _tmp31_);
#line 142 "../src/game.vala"
		cl = g_list_concat (cl, _tmp32_);
#line 928 "game.c"
	}
#line 144 "../src/game.vala"
	if ((x - 1) >= 0) {
#line 932 "game.c"
		Tile** _tmp35_;
		gint _tmp35__length1;
		gint _tmp35__length2;
		Tile* _tmp36_;
#line 144 "../src/game.vala"
		_tmp35_ = self->priv->tiles;
#line 144 "../src/game.vala"
		_tmp35__length1 = self->priv->tiles_length1;
#line 144 "../src/game.vala"
		_tmp35__length2 = self->priv->tiles_length2;
#line 144 "../src/game.vala"
		_tmp36_ = _tmp35_[(y * _tmp35__length2) + (x - 1)];
#line 144 "../src/game.vala"
		_tmp34_ = _tmp36_ != NULL;
#line 947 "game.c"
	} else {
#line 144 "../src/game.vala"
		_tmp34_ = FALSE;
#line 951 "game.c"
	}
#line 144 "../src/game.vala"
	if (_tmp34_) {
#line 955 "game.c"
		Tile** _tmp37_;
		gint _tmp37__length1;
		gint _tmp37__length2;
		Tile* _tmp38_;
#line 144 "../src/game.vala"
		_tmp37_ = self->priv->tiles;
#line 144 "../src/game.vala"
		_tmp37__length1 = self->priv->tiles_length1;
#line 144 "../src/game.vala"
		_tmp37__length2 = self->priv->tiles_length2;
#line 144 "../src/game.vala"
		_tmp38_ = _tmp37_[(y * _tmp37__length2) + (x - 1)];
#line 144 "../src/game.vala"
		_tmp33_ = li->color == _tmp38_->color;
#line 970 "game.c"
	} else {
#line 144 "../src/game.vala"
		_tmp33_ = FALSE;
#line 974 "game.c"
	}
#line 144 "../src/game.vala"
	if (_tmp33_) {
#line 978 "game.c"
		Tile** _tmp39_;
		gint _tmp39__length1;
		gint _tmp39__length2;
		Tile* _tmp40_;
		GList* _tmp41_;
#line 145 "../src/game.vala"
		_tmp39_ = self->priv->tiles;
#line 145 "../src/game.vala"
		_tmp39__length1 = self->priv->tiles_length1;
#line 145 "../src/game.vala"
		_tmp39__length2 = self->priv->tiles_length2;
#line 145 "../src/game.vala"
		_tmp40_ = _tmp39_[(y * _tmp39__length2) + (x - 1)];
#line 145 "../src/game.vala"
		_tmp41_ = _game_connected_tiles (self, _tmp40_);
#line 145 "../src/game.vala"
		cl = g_list_concat (cl, _tmp41_);
#line 996 "game.c"
	}
#line 147 "../src/game.vala"
	result = cl;
#line 147 "../src/game.vala"
	return result;
#line 1002 "game.c"
}

GList*
game_connected_tiles (Game* self,
                      Tile* li)
{
	GList* result = NULL;
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	GList* cl = NULL;
	GList* _tmp4_;
	GList* _tmp5_;
#line 150 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 150 "../src/game.vala"
	g_return_val_if_fail (li != NULL, NULL);
#line 152 "../src/game.vala"
	_tmp0_ = self->priv->tiles;
#line 152 "../src/game.vala"
	_tmp0__length1 = self->priv->tiles_length1;
#line 152 "../src/game.vala"
	_tmp0__length2 = self->priv->tiles_length2;
#line 1026 "game.c"
	{
		Tile** l_collection = NULL;
		gint l_collection_length1 = 0;
		gint l_collection_length2 = 0;
		gint l_it = 0;
#line 152 "../src/game.vala"
		l_collection = _tmp0_;
#line 152 "../src/game.vala"
		l_collection_length1 = _tmp0__length1 * _tmp0__length2;
#line 152 "../src/game.vala"
		for (l_it = 0; l_it < (_tmp0__length1 * _tmp0__length2); l_it = l_it + 1) {
#line 1038 "game.c"
			Tile* _tmp1_;
			Tile* l = NULL;
#line 152 "../src/game.vala"
			_tmp1_ = _g_object_ref0 (l_collection[l_it]);
#line 152 "../src/game.vala"
			l = _tmp1_;
#line 1045 "game.c"
			{
				Tile* _tmp2_;
#line 154 "../src/game.vala"
				_tmp2_ = l;
#line 154 "../src/game.vala"
				if (_tmp2_ != NULL) {
#line 1052 "game.c"
					Tile* _tmp3_;
#line 155 "../src/game.vala"
					_tmp3_ = l;
#line 155 "../src/game.vala"
					_tmp3_->visited = FALSE;
#line 1058 "game.c"
				}
#line 152 "../src/game.vala"
				_g_object_unref0 (l);
#line 1062 "game.c"
			}
		}
	}
#line 158 "../src/game.vala"
	_tmp4_ = _game_connected_tiles (self, li);
#line 158 "../src/game.vala"
	cl = _tmp4_;
#line 161 "../src/game.vala"
	_tmp5_ = cl;
#line 161 "../src/game.vala"
	if (g_list_length (_tmp5_) < ((guint) 2)) {
#line 162 "../src/game.vala"
		(cl == NULL) ? NULL : (cl = (_g_list_free__g_object_unref0_ (cl), NULL));
#line 162 "../src/game.vala"
		cl = NULL;
#line 1078 "game.c"
	}
#line 164 "../src/game.vala"
	result = cl;
#line 164 "../src/game.vala"
	return result;
#line 1084 "game.c"
}

Tile*
game_get_tile (Game* self,
               gint x,
               gint y)
{
	Tile* result = NULL;
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Tile* _tmp1_;
	Tile* _tmp2_;
#line 167 "../src/game.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 169 "../src/game.vala"
	_tmp0_ = self->priv->tiles;
#line 169 "../src/game.vala"
	_tmp0__length1 = self->priv->tiles_length1;
#line 169 "../src/game.vala"
	_tmp0__length2 = self->priv->tiles_length2;
#line 169 "../src/game.vala"
	_tmp1_ = _tmp0_[(y * _tmp0__length2) + x];
#line 169 "../src/game.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 169 "../src/game.vala"
	result = _tmp2_;
#line 169 "../src/game.vala"
	return result;
#line 1114 "game.c"
}

gboolean
game_remove_connected_tiles (Game* self,
                             Tile* tile)
{
	gboolean result = FALSE;
	GList* cl = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	gint new_x = 0;
	GList* _tmp49_;
#line 172 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 172 "../src/game.vala"
	g_return_val_if_fail (tile != NULL, FALSE);
#line 174 "../src/game.vala"
	_tmp0_ = game_connected_tiles (self, tile);
#line 174 "../src/game.vala"
	cl = _tmp0_;
#line 176 "../src/game.vala"
	_tmp1_ = cl;
#line 176 "../src/game.vala"
	if (_tmp1_ == NULL) {
#line 177 "../src/game.vala"
		result = FALSE;
#line 177 "../src/game.vala"
		(cl == NULL) ? NULL : (cl = (_g_list_free__g_object_unref0_ (cl), NULL));
#line 177 "../src/game.vala"
		return result;
#line 1146 "game.c"
	}
#line 179 "../src/game.vala"
	_tmp2_ = cl;
#line 1150 "game.c"
	{
		GList* l_collection = NULL;
		GList* l_it = NULL;
#line 179 "../src/game.vala"
		l_collection = _tmp2_;
#line 179 "../src/game.vala"
		for (l_it = l_collection; l_it != NULL; l_it = l_it->next) {
#line 1158 "game.c"
			Tile* _tmp3_;
			Tile* l = NULL;
#line 179 "../src/game.vala"
			_tmp3_ = _g_object_ref0 ((Tile*) l_it->data);
#line 179 "../src/game.vala"
			l = _tmp3_;
#line 1165 "game.c"
			{
				Tile* _tmp4_;
#line 180 "../src/game.vala"
				_tmp4_ = l;
#line 180 "../src/game.vala"
				tile_set_closed (_tmp4_, TRUE);
#line 179 "../src/game.vala"
				_g_object_unref0 (l);
#line 1174 "game.c"
			}
		}
	}
#line 182 "../src/game.vala"
	new_x = 0;
#line 1180 "game.c"
	{
		gint x = 0;
#line 184 "../src/game.vala"
		x = 0;
#line 1185 "game.c"
		{
			gboolean _tmp5_ = FALSE;
#line 184 "../src/game.vala"
			_tmp5_ = TRUE;
#line 184 "../src/game.vala"
			while (TRUE) {
#line 1192 "game.c"
				gint _tmp7_;
				GList* not_closed_tiles = NULL;
				GList* closed_tiles = NULL;
				GList* _tmp22_;
				gboolean has_empty_col = FALSE;
#line 184 "../src/game.vala"
				if (!_tmp5_) {
#line 1200 "game.c"
					gint _tmp6_;
#line 184 "../src/game.vala"
					_tmp6_ = x;
#line 184 "../src/game.vala"
					x = _tmp6_ + 1;
#line 1206 "game.c"
				}
#line 184 "../src/game.vala"
				_tmp5_ = FALSE;
#line 184 "../src/game.vala"
				_tmp7_ = self->priv->_columns;
#line 184 "../src/game.vala"
				if (!(x < _tmp7_)) {
#line 184 "../src/game.vala"
					break;
#line 1216 "game.c"
				}
#line 186 "../src/game.vala"
				not_closed_tiles = NULL;
#line 187 "../src/game.vala"
				closed_tiles = NULL;
#line 1222 "game.c"
				{
					gint y = 0;
#line 190 "../src/game.vala"
					y = 0;
#line 1227 "game.c"
					{
						gboolean _tmp8_ = FALSE;
#line 190 "../src/game.vala"
						_tmp8_ = TRUE;
#line 190 "../src/game.vala"
						while (TRUE) {
#line 1234 "game.c"
							gint _tmp10_;
							Tile* li = NULL;
							Tile** _tmp11_;
							gint _tmp11__length1;
							gint _tmp11__length2;
							Tile* _tmp12_;
							Tile* _tmp13_;
							Tile* _tmp14_;
							Tile* _tmp15_;
							gboolean _tmp16_;
							gboolean _tmp17_;
#line 190 "../src/game.vala"
							if (!_tmp8_) {
#line 1248 "game.c"
								gint _tmp9_;
#line 190 "../src/game.vala"
								_tmp9_ = y;
#line 190 "../src/game.vala"
								y = _tmp9_ + 1;
#line 1254 "game.c"
							}
#line 190 "../src/game.vala"
							_tmp8_ = FALSE;
#line 190 "../src/game.vala"
							_tmp10_ = self->priv->_rows;
#line 190 "../src/game.vala"
							if (!(y < _tmp10_)) {
#line 190 "../src/game.vala"
								break;
#line 1264 "game.c"
							}
#line 192 "../src/game.vala"
							_tmp11_ = self->priv->tiles;
#line 192 "../src/game.vala"
							_tmp11__length1 = self->priv->tiles_length1;
#line 192 "../src/game.vala"
							_tmp11__length2 = self->priv->tiles_length2;
#line 192 "../src/game.vala"
							_tmp12_ = _tmp11_[(y * _tmp11__length2) + x];
#line 192 "../src/game.vala"
							_tmp13_ = _g_object_ref0 (_tmp12_);
#line 192 "../src/game.vala"
							li = _tmp13_;
#line 194 "../src/game.vala"
							_tmp14_ = li;
#line 194 "../src/game.vala"
							if (_tmp14_ == NULL) {
#line 195 "../src/game.vala"
								_g_object_unref0 (li);
#line 195 "../src/game.vala"
								break;
#line 1286 "game.c"
							}
#line 197 "../src/game.vala"
							_tmp15_ = li;
#line 197 "../src/game.vala"
							_tmp16_ = tile_get_closed (_tmp15_);
#line 197 "../src/game.vala"
							_tmp17_ = _tmp16_;
#line 197 "../src/game.vala"
							if (_tmp17_) {
#line 1296 "game.c"
								Tile* _tmp18_;
								Tile* _tmp19_;
#line 198 "../src/game.vala"
								_tmp18_ = li;
#line 198 "../src/game.vala"
								_tmp19_ = _g_object_ref0 (_tmp18_);
#line 198 "../src/game.vala"
								closed_tiles = g_list_append (closed_tiles, _tmp19_);
#line 1305 "game.c"
							} else {
								Tile* _tmp20_;
								Tile* _tmp21_;
#line 200 "../src/game.vala"
								_tmp20_ = li;
#line 200 "../src/game.vala"
								_tmp21_ = _g_object_ref0 (_tmp20_);
#line 200 "../src/game.vala"
								not_closed_tiles = g_list_append (not_closed_tiles, _tmp21_);
#line 1315 "game.c"
							}
#line 190 "../src/game.vala"
							_g_object_unref0 (li);
#line 1319 "game.c"
						}
					}
				}
#line 204 "../src/game.vala"
				_tmp22_ = closed_tiles;
#line 204 "../src/game.vala"
				closed_tiles = NULL;
#line 204 "../src/game.vala"
				not_closed_tiles = g_list_concat (not_closed_tiles, _tmp22_);
#line 1329 "game.c"
				{
					gint y = 0;
#line 207 "../src/game.vala"
					y = 0;
#line 1334 "game.c"
					{
						gboolean _tmp23_ = FALSE;
#line 207 "../src/game.vala"
						_tmp23_ = TRUE;
#line 207 "../src/game.vala"
						while (TRUE) {
#line 1341 "game.c"
							gint _tmp25_;
							Tile** _tmp26_;
							gint _tmp26__length1;
							gint _tmp26__length2;
							GList* _tmp27_;
							gconstpointer _tmp28_;
							Tile* _tmp29_;
#line 207 "../src/game.vala"
							if (!_tmp23_) {
#line 1351 "game.c"
								gint _tmp24_;
#line 207 "../src/game.vala"
								_tmp24_ = y;
#line 207 "../src/game.vala"
								y = _tmp24_ + 1;
#line 1357 "game.c"
							}
#line 207 "../src/game.vala"
							_tmp23_ = FALSE;
#line 207 "../src/game.vala"
							_tmp25_ = self->priv->_rows;
#line 207 "../src/game.vala"
							if (!(y < _tmp25_)) {
#line 207 "../src/game.vala"
								break;
#line 1367 "game.c"
							}
#line 208 "../src/game.vala"
							_tmp26_ = self->priv->tiles;
#line 208 "../src/game.vala"
							_tmp26__length1 = self->priv->tiles_length1;
#line 208 "../src/game.vala"
							_tmp26__length2 = self->priv->tiles_length2;
#line 208 "../src/game.vala"
							_tmp27_ = not_closed_tiles;
#line 208 "../src/game.vala"
							_tmp28_ = g_list_nth_data (_tmp27_, (guint) y);
#line 208 "../src/game.vala"
							_tmp29_ = _g_object_ref0 ((Tile*) _tmp28_);
#line 208 "../src/game.vala"
							_g_object_unref0 (_tmp26_[(y * _tmp26__length2) + new_x]);
#line 208 "../src/game.vala"
							_tmp26_[(y * _tmp26__length2) + new_x] = _tmp29_;
#line 1385 "game.c"
						}
					}
				}
#line 211 "../src/game.vala"
				has_empty_col = TRUE;
#line 1391 "game.c"
				{
					gint y = 0;
#line 214 "../src/game.vala"
					y = 0;
#line 1396 "game.c"
					{
						gboolean _tmp30_ = FALSE;
#line 214 "../src/game.vala"
						_tmp30_ = TRUE;
#line 214 "../src/game.vala"
						while (TRUE) {
#line 1403 "game.c"
							gint _tmp32_;
							Tile* l = NULL;
							Tile** _tmp33_;
							gint _tmp33__length1;
							gint _tmp33__length2;
							Tile* _tmp34_;
							Tile* _tmp35_;
							Tile* _tmp36_;
							Tile* _tmp37_;
							Tile* _tmp38_;
							gboolean _tmp39_;
							gboolean _tmp40_;
#line 214 "../src/game.vala"
							if (!_tmp30_) {
#line 1418 "game.c"
								gint _tmp31_;
#line 214 "../src/game.vala"
								_tmp31_ = y;
#line 214 "../src/game.vala"
								y = _tmp31_ + 1;
#line 1424 "game.c"
							}
#line 214 "../src/game.vala"
							_tmp30_ = FALSE;
#line 214 "../src/game.vala"
							_tmp32_ = self->priv->_rows;
#line 214 "../src/game.vala"
							if (!(y < _tmp32_)) {
#line 214 "../src/game.vala"
								break;
#line 1434 "game.c"
							}
#line 216 "../src/game.vala"
							_tmp33_ = self->priv->tiles;
#line 216 "../src/game.vala"
							_tmp33__length1 = self->priv->tiles_length1;
#line 216 "../src/game.vala"
							_tmp33__length2 = self->priv->tiles_length2;
#line 216 "../src/game.vala"
							_tmp34_ = _tmp33_[(y * _tmp33__length2) + new_x];
#line 216 "../src/game.vala"
							_tmp35_ = _g_object_ref0 (_tmp34_);
#line 216 "../src/game.vala"
							l = _tmp35_;
#line 218 "../src/game.vala"
							_tmp36_ = l;
#line 218 "../src/game.vala"
							if (_tmp36_ == NULL) {
#line 219 "../src/game.vala"
								_g_object_unref0 (l);
#line 219 "../src/game.vala"
								break;
#line 1456 "game.c"
							}
#line 221 "../src/game.vala"
							_tmp37_ = l;
#line 221 "../src/game.vala"
							tile_update_position (_tmp37_, new_x, y);
#line 223 "../src/game.vala"
							_tmp38_ = l;
#line 223 "../src/game.vala"
							_tmp39_ = tile_get_closed (_tmp38_);
#line 223 "../src/game.vala"
							_tmp40_ = _tmp39_;
#line 223 "../src/game.vala"
							if (!_tmp40_) {
#line 224 "../src/game.vala"
								has_empty_col = FALSE;
#line 1472 "game.c"
							}
#line 214 "../src/game.vala"
							_g_object_unref0 (l);
#line 1476 "game.c"
						}
					}
				}
#line 228 "../src/game.vala"
				if (!has_empty_col) {
#line 1482 "game.c"
					gint _tmp41_;
#line 229 "../src/game.vala"
					_tmp41_ = new_x;
#line 229 "../src/game.vala"
					new_x = _tmp41_ + 1;
#line 1488 "game.c"
				}
#line 184 "../src/game.vala"
				(closed_tiles == NULL) ? NULL : (closed_tiles = (_g_list_free__g_object_unref0_ (closed_tiles), NULL));
#line 184 "../src/game.vala"
				(not_closed_tiles == NULL) ? NULL : (not_closed_tiles = (_g_list_free__g_object_unref0_ (not_closed_tiles), NULL));
#line 1494 "game.c"
			}
		}
	}
	{
		gboolean _tmp42_ = FALSE;
#line 233 "../src/game.vala"
		_tmp42_ = TRUE;
#line 233 "../src/game.vala"
		while (TRUE) {
#line 1504 "game.c"
			gint _tmp44_;
#line 233 "../src/game.vala"
			if (!_tmp42_) {
#line 1508 "game.c"
				gint _tmp43_;
#line 233 "../src/game.vala"
				_tmp43_ = new_x;
#line 233 "../src/game.vala"
				new_x = _tmp43_ + 1;
#line 1514 "game.c"
			}
#line 233 "../src/game.vala"
			_tmp42_ = FALSE;
#line 233 "../src/game.vala"
			_tmp44_ = self->priv->_columns;
#line 233 "../src/game.vala"
			if (!(new_x < _tmp44_)) {
#line 233 "../src/game.vala"
				break;
#line 1524 "game.c"
			}
			{
				gint y = 0;
#line 234 "../src/game.vala"
				y = 0;
#line 1530 "game.c"
				{
					gboolean _tmp45_ = FALSE;
#line 234 "../src/game.vala"
					_tmp45_ = TRUE;
#line 234 "../src/game.vala"
					while (TRUE) {
#line 1537 "game.c"
						gint _tmp47_;
						Tile** _tmp48_;
						gint _tmp48__length1;
						gint _tmp48__length2;
#line 234 "../src/game.vala"
						if (!_tmp45_) {
#line 1544 "game.c"
							gint _tmp46_;
#line 234 "../src/game.vala"
							_tmp46_ = y;
#line 234 "../src/game.vala"
							y = _tmp46_ + 1;
#line 1550 "game.c"
						}
#line 234 "../src/game.vala"
						_tmp45_ = FALSE;
#line 234 "../src/game.vala"
						_tmp47_ = self->priv->_rows;
#line 234 "../src/game.vala"
						if (!(y < _tmp47_)) {
#line 234 "../src/game.vala"
							break;
#line 1560 "game.c"
						}
#line 235 "../src/game.vala"
						_tmp48_ = self->priv->tiles;
#line 235 "../src/game.vala"
						_tmp48__length1 = self->priv->tiles_length1;
#line 235 "../src/game.vala"
						_tmp48__length2 = self->priv->tiles_length2;
#line 235 "../src/game.vala"
						_g_object_unref0 (_tmp48_[(y * _tmp48__length2) + new_x]);
#line 235 "../src/game.vala"
						_tmp48_[(y * _tmp48__length2) + new_x] = NULL;
#line 1572 "game.c"
					}
				}
			}
		}
	}
#line 237 "../src/game.vala"
	_tmp49_ = cl;
#line 237 "../src/game.vala"
	game_increment_score_from_tiles (self, (gint) g_list_length (_tmp49_));
#line 239 "../src/game.vala"
	if (!self->priv->is_started) {
#line 240 "../src/game.vala"
		self->priv->is_started = TRUE;
#line 241 "../src/game.vala"
		g_signal_emit (self, game_signals[GAME_STARTED_SIGNAL], 0);
#line 1588 "game.c"
	}
#line 244 "../src/game.vala"
	if (game_has_completed (self)) {
#line 246 "../src/game.vala"
		if (game_has_won (self)) {
#line 247 "../src/game.vala"
			game_increment_score (self, 1000);
#line 1596 "game.c"
		}
#line 248 "../src/game.vala"
		g_signal_emit (self, game_signals[GAME_COMPLETE_SIGNAL], 0);
#line 1600 "game.c"
	}
#line 251 "../src/game.vala"
	result = FALSE;
#line 251 "../src/game.vala"
	(cl == NULL) ? NULL : (cl = (_g_list_free__g_object_unref0_ (cl), NULL));
#line 251 "../src/game.vala"
	return result;
#line 1608 "game.c"
}

void
game_reset_visit (Game* self)
{
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
#line 254 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 256 "../src/game.vala"
	_tmp0_ = self->priv->tiles;
#line 256 "../src/game.vala"
	_tmp0__length1 = self->priv->tiles_length1;
#line 256 "../src/game.vala"
	_tmp0__length2 = self->priv->tiles_length2;
#line 1625 "game.c"
	{
		Tile** l_collection = NULL;
		gint l_collection_length1 = 0;
		gint l_collection_length2 = 0;
		gint l_it = 0;
#line 256 "../src/game.vala"
		l_collection = _tmp0_;
#line 256 "../src/game.vala"
		l_collection_length1 = _tmp0__length1 * _tmp0__length2;
#line 256 "../src/game.vala"
		for (l_it = 0; l_it < (_tmp0__length1 * _tmp0__length2); l_it = l_it + 1) {
#line 1637 "game.c"
			Tile* _tmp1_;
			Tile* l = NULL;
#line 256 "../src/game.vala"
			_tmp1_ = _g_object_ref0 (l_collection[l_it]);
#line 256 "../src/game.vala"
			l = _tmp1_;
#line 1644 "game.c"
			{
				Tile* _tmp2_;
#line 258 "../src/game.vala"
				_tmp2_ = l;
#line 258 "../src/game.vala"
				if (_tmp2_ != NULL) {
#line 1651 "game.c"
					Tile* _tmp3_;
#line 259 "../src/game.vala"
					_tmp3_ = l;
#line 259 "../src/game.vala"
					_tmp3_->visited = FALSE;
#line 1657 "game.c"
				}
#line 256 "../src/game.vala"
				_g_object_unref0 (l);
#line 1661 "game.c"
			}
		}
	}
}

gboolean
game_has_completed (Game* self)
{
	gboolean result = FALSE;
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
#line 263 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 265 "../src/game.vala"
	_tmp0_ = self->priv->tiles;
#line 265 "../src/game.vala"
	_tmp0__length1 = self->priv->tiles_length1;
#line 265 "../src/game.vala"
	_tmp0__length2 = self->priv->tiles_length2;
#line 1682 "game.c"
	{
		Tile** l_collection = NULL;
		gint l_collection_length1 = 0;
		gint l_collection_length2 = 0;
		gint l_it = 0;
#line 265 "../src/game.vala"
		l_collection = _tmp0_;
#line 265 "../src/game.vala"
		l_collection_length1 = _tmp0__length1 * _tmp0__length2;
#line 265 "../src/game.vala"
		for (l_it = 0; l_it < (_tmp0__length1 * _tmp0__length2); l_it = l_it + 1) {
#line 1694 "game.c"
			Tile* _tmp1_;
			Tile* l = NULL;
#line 265 "../src/game.vala"
			_tmp1_ = _g_object_ref0 (l_collection[l_it]);
#line 265 "../src/game.vala"
			l = _tmp1_;
#line 1701 "game.c"
			{
				gboolean _tmp2_ = FALSE;
				gboolean _tmp3_ = FALSE;
				Tile* _tmp4_;
#line 267 "../src/game.vala"
				_tmp4_ = l;
#line 267 "../src/game.vala"
				if (_tmp4_ != NULL) {
#line 1710 "game.c"
					Tile* _tmp5_;
					gboolean _tmp6_;
					gboolean _tmp7_;
#line 267 "../src/game.vala"
					_tmp5_ = l;
#line 267 "../src/game.vala"
					_tmp6_ = tile_get_closed (_tmp5_);
#line 267 "../src/game.vala"
					_tmp7_ = _tmp6_;
#line 267 "../src/game.vala"
					_tmp3_ = !_tmp7_;
#line 1722 "game.c"
				} else {
#line 267 "../src/game.vala"
					_tmp3_ = FALSE;
#line 1726 "game.c"
				}
#line 267 "../src/game.vala"
				if (_tmp3_) {
#line 1730 "game.c"
					Tile* _tmp8_;
					GList* _tmp9_;
					GList* _tmp10_;
#line 267 "../src/game.vala"
					_tmp8_ = l;
#line 267 "../src/game.vala"
					_tmp9_ = game_connected_tiles (self, _tmp8_);
#line 267 "../src/game.vala"
					_tmp10_ = _tmp9_;
#line 267 "../src/game.vala"
					_tmp2_ = g_list_length (_tmp10_) > ((guint) 1);
#line 267 "../src/game.vala"
					(_tmp10_ == NULL) ? NULL : (_tmp10_ = (_g_list_free__g_object_unref0_ (_tmp10_), NULL));
#line 1744 "game.c"
				} else {
#line 267 "../src/game.vala"
					_tmp2_ = FALSE;
#line 1748 "game.c"
				}
#line 267 "../src/game.vala"
				if (_tmp2_) {
#line 268 "../src/game.vala"
					result = FALSE;
#line 268 "../src/game.vala"
					_g_object_unref0 (l);
#line 268 "../src/game.vala"
					return result;
#line 1758 "game.c"
				}
#line 265 "../src/game.vala"
				_g_object_unref0 (l);
#line 1762 "game.c"
			}
		}
	}
#line 271 "../src/game.vala"
	result = TRUE;
#line 271 "../src/game.vala"
	return result;
#line 1770 "game.c"
}

gboolean
game_has_won (Game* self)
{
	gboolean result = FALSE;
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
#line 274 "../src/game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 276 "../src/game.vala"
	_tmp0_ = self->priv->tiles;
#line 276 "../src/game.vala"
	_tmp0__length1 = self->priv->tiles_length1;
#line 276 "../src/game.vala"
	_tmp0__length2 = self->priv->tiles_length2;
#line 1788 "game.c"
	{
		Tile** l_collection = NULL;
		gint l_collection_length1 = 0;
		gint l_collection_length2 = 0;
		gint l_it = 0;
#line 276 "../src/game.vala"
		l_collection = _tmp0_;
#line 276 "../src/game.vala"
		l_collection_length1 = _tmp0__length1 * _tmp0__length2;
#line 276 "../src/game.vala"
		for (l_it = 0; l_it < (_tmp0__length1 * _tmp0__length2); l_it = l_it + 1) {
#line 1800 "game.c"
			Tile* _tmp1_;
			Tile* l = NULL;
#line 276 "../src/game.vala"
			_tmp1_ = _g_object_ref0 (l_collection[l_it]);
#line 276 "../src/game.vala"
			l = _tmp1_;
#line 1807 "game.c"
			{
				gboolean _tmp2_ = FALSE;
				Tile* _tmp3_;
#line 278 "../src/game.vala"
				_tmp3_ = l;
#line 278 "../src/game.vala"
				if (_tmp3_ != NULL) {
#line 1815 "game.c"
					Tile* _tmp4_;
					gboolean _tmp5_;
					gboolean _tmp6_;
#line 278 "../src/game.vala"
					_tmp4_ = l;
#line 278 "../src/game.vala"
					_tmp5_ = tile_get_closed (_tmp4_);
#line 278 "../src/game.vala"
					_tmp6_ = _tmp5_;
#line 278 "../src/game.vala"
					_tmp2_ = !_tmp6_;
#line 1827 "game.c"
				} else {
#line 278 "../src/game.vala"
					_tmp2_ = FALSE;
#line 1831 "game.c"
				}
#line 278 "../src/game.vala"
				if (_tmp2_) {
#line 279 "../src/game.vala"
					result = FALSE;
#line 279 "../src/game.vala"
					_g_object_unref0 (l);
#line 279 "../src/game.vala"
					return result;
#line 1841 "game.c"
				}
#line 276 "../src/game.vala"
				_g_object_unref0 (l);
#line 1845 "game.c"
			}
		}
	}
#line 282 "../src/game.vala"
	result = TRUE;
#line 282 "../src/game.vala"
	return result;
#line 1853 "game.c"
}

void
game_increment_score_from_tiles (Game* self,
                                 gint n_tiles)
{
	gint points_awarded = 0;
#line 285 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 287 "../src/game.vala"
	points_awarded = 0;
#line 289 "../src/game.vala"
	if (n_tiles >= 3) {
#line 290 "../src/game.vala"
		points_awarded = (n_tiles - 2) * (n_tiles - 2);
#line 1869 "game.c"
	}
#line 292 "../src/game.vala"
	game_increment_score (self, points_awarded);
#line 1873 "game.c"
}

void
game_increment_score (Game* self,
                      gint increment)
{
	gint _tmp0_;
#line 295 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 297 "../src/game.vala"
	_tmp0_ = self->priv->_score;
#line 297 "../src/game.vala"
	game_set_score (self, _tmp0_ + increment);
#line 298 "../src/game.vala"
	g_signal_emit (self, game_signals[GAME_UPDATE_SCORE_SIGNAL], 0, increment);
#line 1889 "game.c"
}

gint
game_get_score (Game* self)
{
	gint result;
#line 75 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 75 "../src/game.vala"
	result = self->priv->_score;
#line 75 "../src/game.vala"
	return result;
#line 1902 "game.c"
}

void
game_set_score (Game* self,
                gint value)
{
#line 75 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/game.vala"
	if (game_get_score (self) != value) {
#line 75 "../src/game.vala"
		self->priv->_score = value;
#line 75 "../src/game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_properties[GAME_SCORE_PROPERTY]);
#line 1917 "game.c"
	}
}

gint
game_get_color_num (Game* self)
{
	gint result;
#line 80 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 80 "../src/game.vala"
	result = self->priv->_color_num;
#line 80 "../src/game.vala"
	return result;
#line 1931 "game.c"
}

void
game_set_color_num (Game* self,
                    gint value)
{
	gboolean _tmp0_ = FALSE;
#line 81 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/game.vala"
	if (value < 2) {
#line 83 "../src/game.vala"
		_tmp0_ = TRUE;
#line 1945 "game.c"
	} else {
#line 83 "../src/game.vala"
		_tmp0_ = value > 4;
#line 1949 "game.c"
	}
#line 83 "../src/game.vala"
	if (_tmp0_) {
#line 84 "../src/game.vala"
		self->priv->_color_num = 3;
#line 1955 "game.c"
	} else {
#line 86 "../src/game.vala"
		self->priv->_color_num = value;
#line 1959 "game.c"
	}
#line 81 "../src/game.vala"
	g_object_notify_by_pspec ((GObject *) self, game_properties[GAME_COLOR_NUM_PROPERTY]);
#line 1963 "game.c"
}

gint
game_get_rows (Game* self)
{
	gint result;
#line 91 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 91 "../src/game.vala"
	result = self->priv->_rows;
#line 91 "../src/game.vala"
	return result;
#line 1976 "game.c"
}

void
game_set_rows (Game* self,
               gint value)
{
#line 91 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 91 "../src/game.vala"
	if (game_get_rows (self) != value) {
#line 91 "../src/game.vala"
		self->priv->_rows = value;
#line 91 "../src/game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_properties[GAME_ROWS_PROPERTY]);
#line 1991 "game.c"
	}
}

gint
game_get_columns (Game* self)
{
	gint result;
#line 92 "../src/game.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 92 "../src/game.vala"
	result = self->priv->_columns;
#line 92 "../src/game.vala"
	return result;
#line 2005 "game.c"
}

void
game_set_columns (Game* self,
                  gint value)
{
#line 92 "../src/game.vala"
	g_return_if_fail (self != NULL);
#line 92 "../src/game.vala"
	if (game_get_columns (self) != value) {
#line 92 "../src/game.vala"
		self->priv->_columns = value;
#line 92 "../src/game.vala"
		g_object_notify_by_pspec ((GObject *) self, game_properties[GAME_COLUMNS_PROPERTY]);
#line 2020 "game.c"
	}
}

static void
game_class_init (GameClass * klass,
                 gpointer klass_data)
{
#line 69 "../src/game.vala"
	game_parent_class = g_type_class_peek_parent (klass);
#line 69 "../src/game.vala"
	g_type_class_adjust_private_offset (klass, &Game_private_offset);
#line 69 "../src/game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_game_get_property;
#line 69 "../src/game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_game_set_property;
#line 69 "../src/game.vala"
	G_OBJECT_CLASS (klass)->finalize = game_finalize;
#line 69 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_SCORE_PROPERTY, game_properties[GAME_SCORE_PROPERTY] = g_param_spec_int ("score", "score", "score", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 69 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_COLOR_NUM_PROPERTY, game_properties[GAME_COLOR_NUM_PROPERTY] = g_param_spec_int ("color-num", "color-num", "color-num", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 69 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_ROWS_PROPERTY, game_properties[GAME_ROWS_PROPERTY] = g_param_spec_int ("rows", "rows", "rows", G_MININT, G_MAXINT, 8, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 69 "../src/game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_COLUMNS_PROPERTY, game_properties[GAME_COLUMNS_PROPERTY] = g_param_spec_int ("columns", "columns", "columns", G_MININT, G_MAXINT, 8, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 69 "../src/game.vala"
	game_signals[GAME_UPDATE_SCORE_SIGNAL] = g_signal_new ("update-score", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
#line 69 "../src/game.vala"
	game_signals[GAME_COMPLETE_SIGNAL] = g_signal_new ("complete", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 69 "../src/game.vala"
	game_signals[GAME_STARTED_SIGNAL] = g_signal_new ("started", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2052 "game.c"
}

static void
game_instance_init (Game * self,
                    gpointer klass)
{
#line 69 "../src/game.vala"
	self->priv = game_get_instance_private (self);
#line 72 "../src/game.vala"
	self->priv->is_started = FALSE;
#line 75 "../src/game.vala"
	self->priv->_score = 0;
#line 77 "../src/game.vala"
	self->priv->_color_num = 3;
#line 91 "../src/game.vala"
	self->priv->_rows = 8;
#line 92 "../src/game.vala"
	self->priv->_columns = 8;
#line 2071 "game.c"
}

static void
game_finalize (GObject * obj)
{
	Game * self;
#line 69 "../src/game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
#line 71 "../src/game.vala"
	self->priv->tiles = (_vala_array_free (self->priv->tiles, self->priv->tiles_length1 * self->priv->tiles_length2, (GDestroyNotify) g_object_unref), NULL);
#line 69 "../src/game.vala"
	G_OBJECT_CLASS (game_parent_class)->finalize (obj);
#line 2084 "game.c"
}

/**
 *  This is the model layer of the whole game. All game logic goes here. This class tries not to
 *  bring in any visual stuff to comply the separation of view-model idea.
 */
GType
game_get_type (void)
{
	static volatile gsize game_type_id__volatile = 0;
	if (g_once_init_enter (&game_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Game), 0, (GInstanceInitFunc) game_instance_init, NULL };
		GType game_type_id;
		game_type_id = g_type_register_static (G_TYPE_OBJECT, "Game", &g_define_type_info, 0);
		Game_private_offset = g_type_add_instance_private (game_type_id, sizeof (GamePrivate));
		g_once_init_leave (&game_type_id__volatile, game_type_id);
	}
	return game_type_id__volatile;
}

static void
_vala_game_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 69 "../src/game.vala"
	switch (property_id) {
#line 69 "../src/game.vala"
		case GAME_SCORE_PROPERTY:
#line 69 "../src/game.vala"
		g_value_set_int (value, game_get_score (self));
#line 69 "../src/game.vala"
		break;
#line 69 "../src/game.vala"
		case GAME_COLOR_NUM_PROPERTY:
#line 69 "../src/game.vala"
		g_value_set_int (value, game_get_color_num (self));
#line 69 "../src/game.vala"
		break;
#line 69 "../src/game.vala"
		case GAME_ROWS_PROPERTY:
#line 69 "../src/game.vala"
		g_value_set_int (value, game_get_rows (self));
#line 69 "../src/game.vala"
		break;
#line 69 "../src/game.vala"
		case GAME_COLUMNS_PROPERTY:
#line 69 "../src/game.vala"
		g_value_set_int (value, game_get_columns (self));
#line 69 "../src/game.vala"
		break;
#line 2139 "game.c"
		default:
#line 69 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 69 "../src/game.vala"
		break;
#line 2145 "game.c"
	}
}

static void
_vala_game_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
#line 69 "../src/game.vala"
	switch (property_id) {
#line 69 "../src/game.vala"
		case GAME_SCORE_PROPERTY:
#line 69 "../src/game.vala"
		game_set_score (self, g_value_get_int (value));
#line 69 "../src/game.vala"
		break;
#line 69 "../src/game.vala"
		case GAME_COLOR_NUM_PROPERTY:
#line 69 "../src/game.vala"
		game_set_color_num (self, g_value_get_int (value));
#line 69 "../src/game.vala"
		break;
#line 69 "../src/game.vala"
		case GAME_ROWS_PROPERTY:
#line 69 "../src/game.vala"
		game_set_rows (self, g_value_get_int (value));
#line 69 "../src/game.vala"
		break;
#line 69 "../src/game.vala"
		case GAME_COLUMNS_PROPERTY:
#line 69 "../src/game.vala"
		game_set_columns (self, g_value_get_int (value));
#line 69 "../src/game.vala"
		break;
#line 2183 "game.c"
		default:
#line 69 "../src/game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 69 "../src/game.vala"
		break;
#line 2189 "game.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

